// FileWriter.cpp: CFileWriter NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "UdpOutput.h"
#include <memory.h>
#pragma comment(lib,"ws2_32.lib")

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CUdpOutput::CUdpOutput()
	: IMediaDecoder()
{
	m_Buffer = new CBuffer(UDP_BUF_LEN);
}

CUdpOutput::~CUdpOutput()
{
	CloseUdpPort();
	delete m_Buffer;
}

void CUdpOutput::Reset(void)
{
}

const DWORD CUdpOutput::GetInputNum(void) const
{
	return 1;
}

const DWORD CUdpOutput::GetOutputNum(void) const
{
	return 0;
}

const bool CUdpOutput::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex > GetInputNum())return false;

	m_Buffer->Put((BYTE*)pMediaData->GetData(),pMediaData->GetSize());
	// ̓f[^폜
	pMediaData->Delete();

	BYTE buf[UDP_BUF_LEN];
	int len;

	if(m_Buffer->GetDataSize()>=UDP_BUF_LEN)
	{
		len=m_Buffer->Get(buf,UDP_BUF_LEN);
		if(len>0)
			sendto(m_sock, (char*)buf,len, 0, (struct sockaddr *)&m_server, sizeof(m_server));
	}


	return true;
}

const bool CUdpOutput::OpenUdpPort(LPCTSTR lpszUdpPortName)
{
	char buf[256];
	UINT portno = 1234;
	unsigned int **addrptr;
	char szHostName[256];
	char* pSep;

	WSADATA wsaData;
	WSAStartup(MAKEWORD(2,0), &wsaData);

	if((pSep = strchr((char*)lpszUdpPortName,':')) != NULL) {
		strncpy(szHostName,lpszUdpPortName,pSep-lpszUdpPortName);
		szHostName[pSep-lpszUdpPortName] = 0x00;
		portno = atoi(pSep+1);
	}
	else {
		strcpy(szHostName,"127.0.0.1");
		portno = atoi(lpszUdpPortName);
	}

	m_sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (m_sock == INVALID_SOCKET)
		return FALSE;

	m_server.sin_family = AF_INET;
	m_server.sin_port = htons(portno);

	m_server.sin_addr.S_un.S_addr = inet_addr(szHostName);
	if (m_server.sin_addr.S_un.S_addr == 0xffffffff) {
		return FALSE;
		//struct hostent *host;

		//host = gethostbyname(szHostName);
		//if (host == NULL) {
		//	closesocket(m_sock);
		//	return FALSE;
		// }
		//addrptr = (unsigned int **)host->h_addr_list;
		//if (*addrptr == NULL) {
		//	closesocket(m_sock);
		//	return FALSE;
		//}
		//m_server.sin_addr.S_un.S_addr = *(*addrptr);
	}
	m_Buffer->Clear();
	return TRUE;
}

void CUdpOutput::CloseUdpPort(void)
{
	m_Buffer->Clear();
	if(m_sock != INVALID_SOCKET) {
		closesocket(m_sock);
		m_sock = INVALID_SOCKET;
	}
	WSACleanup();
}
